// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_TEST_LANG_HASHING_H
#define FENNEC_TEST_LANG_HASHING_H

#include <fennec/lang/hashing.h>
#include "../../test.h"

namespace fennec::test
{

	inline void fennec_test_lang_hashing() {

		constexpr size_t   num  = 61;
		constexpr float_t  numf = bit_cast<float>(uint32_t(num));
		constexpr double_t numd = bit_cast<double>(num);
		constexpr size_t   exp  = hash<size_t>()(num);

		fennec_test_run(hash<int8_t>()(num),   exp);
		fennec_test_run(hash<uint8_t>()(num),  exp);
		fennec_test_run(hash<int16_t>()(num),  exp);
		fennec_test_run(hash<uint16_t>()(num), exp);
		fennec_test_run(hash<int32_t>()(num),  exp);
		fennec_test_run(hash<uint32_t>()(num), exp);
		fennec_test_run(hash<int64_t>()(num),  exp);
		fennec_test_run(hash<uint64_t>()(num), exp);

		fennec_test_spacer(1);

		fennec_test_run(hash<float_t>()(numf), exp);
		fennec_test_run(hash<double_t>()(numd), exp);
	}

}

#endif // FENNEC_TEST_LANG_HASHING_H
